/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 07.01.2009
Author  : 
Company : 
Comments: 


Chip type           : ATmega64
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 1024
*****************************************************/

#include <mega64.h>
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm
#include <lcd.h>
#include <stdio.h>

char lcd_buffer[33];
int angle_a,angle_b=120,angle_c=240,u_a,w_a,u_b,w_b,u_c,w_c;
unsigned char table[91]={  2, 3, 5, 7, 9, 10,12,14,16,17,
                           19,20,22,24,26,28,29,31,33,34,
                           36,37,39,40,42,44,45,47,48,50,
                           52,53,54,56,57,59,60,62,63,64,
                           66,67,68,69,71,72,73,74,75,76,
                           77,79,80,81,82,83,84,85,86,87,
                           87,88,89,90,91,91,92,93,93,94,
                           95,95,96,96,97,97,97,98,98,98,
                           99,99,99,99,99,99,99,99,99,100,100};
unsigned char f,cnt,cntt,fr=6,i;                           
                           
// Timer 0 output compare interrupt service routine
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
// Place your code here
if(angle_a==360)angle_a=0;
if(angle_b==360)angle_b=0;
if(angle_c==360)angle_c=0;
if(cntt==18)
{
PORTB.0=~PORTB.0;
cntt=0;
}
cntt++;
angle_a++;
angle_b++;
angle_c++;
if(u_a<5)u_a=255;
OCR1AL=u_a;
if(w_a<5)w_a=255;
OCR3AL=w_a;
if(u_b<5)u_b=255;
OCR1BL=u_b;
if(w_b<5)w_b=255;
OCR3BL=w_b;
if(u_c<5)u_c=255;
OCR1CL=u_c;
if(w_c<5)w_c=255;
OCR1CL=w_c;
}

// Timer 1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
 

}

// Timer 2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here
if(cnt==5)
{
cnt=0;
if(fr<50 && PINB.1==0)fr++;
if(fr>6 && PINB.2==0)fr--;
f=(1389/fr)-1;
OCR0=f;
}

cnt++;

}

// Timer 3 overflow interrupt service routine
interrupt [TIM3_OVF] void timer3_ovf_isr(void)
{


}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=P State2=P State1=P State0=0 
PORTB=0x0E;
DDRB=0xF1;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Port E initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=0 State2=T State1=T State0=T 
PORTE=0x00;
DDRE=0x38;

// Port F initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTF=0x00;
DDRF=0x00;

// Port G initialization
// Func4=In Func3=In Func2=In Func1=In Func0=In 
// State4=T State3=T State2=T State1=T State0=T 
PORTG=0x00;
DDRG=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 500,000 kHz
// Mode: CTC top=OCR0
// OC0 output: Disconnected
ASSR=0x00;
TCCR0=0x0B;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 2000,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// OC1C output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0xA9;
TCCR1B=0x02;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: 2000,000 kHz
// Mode: Ph. correct PWM top=00FFh
// Noise Canceler: Off
// Input Capture on Falling Edge
// OC3A output: Non-Inv.
// OC3B output: Non-Inv.
// OC3C output: Non-Inv.
// Timer 3 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR3A=0xA9;
TCCR3B=0x02;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=127;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x00;
EICRB=0x00;
EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x46;
ETIMSK=0x04;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;
lcd_init(16);
// Global enable interrupts
#asm("sei")

while (1)
      {
      lcd_gotoxy(0,0);
      sprintf(lcd_buffer,"fr=%u   ",fr);
      lcd_puts(lcd_buffer); 
      // Place your code here
      if(angle_a>0 && angle_a<=90) i=angle_a;
      if(angle_a>90 && angle_a<=180) i=90-(angle_a-90);
      if(angle_a>180 && angle_a<=270) i=angle_a-180;
      if(angle_a>270 && angle_a<=360) i=90-(angle_a-270);
      if(angle_a<180) 
      {
      u_a=(table[i]*5*fr)/100;
      w_a=255;
      }
      if(angle_a>180)
      {
      u_a=255;
      w_a=(table[i]*5*fr)/100;
      }
      if(angle_b>0 && angle_b<=90) i=angle_b;
      if(angle_b>90 && angle_b<=180) i=90-(angle_b-90);
      if(angle_b>180 && angle_b<=270) i=angle_b-180;
      if(angle_b>270 && angle_b<=360) i=90-(angle_b-270);
      if(angle_b<180) 
      {
      u_b=(table[i]*5*fr)/100;
      w_b=255;
      }
      if(angle_b>180)
      {
      u_b=255;
      w_b=(table[i]*5*fr)/100;
      }
      if(angle_c>0 && angle_c<=90) i=angle_c;
      if(angle_c>90 && angle_c<=180) i=90-(angle_c-90);
      if(angle_c>180 && angle_c<=270) i=angle_c-180;
      if(angle_c>270 && angle_c<=360) i=90-(angle_c-270);
      if(angle_c<180) 
      {
      u_c=(table[i]*5*fr)/100;
      w_c=255;
      }
      if(angle_c>180)
      {
      u_c=255;
      w_c=(table[i]*5*fr)/100;
      }
          
      };
}